Index: linux-kj/drivers/scsi/FlashPoint.c
===================================================================
--- linux-kj.orig/drivers/scsi/FlashPoint.c	2005-12-05 13:19:06.000000000 +0300
+++ linux-kj/drivers/scsi/FlashPoint.c	2005-12-05 13:19:06.000000000 +0300
@@ -1911,237 +1745,259 @@ static unsigned char FlashPoint_Interrup
  *---------------------------------------------------------------------*/
 static int FlashPoint_HandleInterrupt(unsigned long pCurrCard)
 {
-   struct sccb * currSCCB;
-   unsigned char thisCard,result,bm_status, bm_int_st;
-   unsigned short hp_int;
-   unsigned char i, target;
-   unsigned long ioport;
-
-   thisCard = ((struct sccb_card *)pCurrCard)->cardIndex;
-   ioport = ((struct sccb_card *)pCurrCard)->ioPort;
+	struct sccb *currSCCB;
+	unsigned char thisCard, result, bm_status, bm_int_st;
+	unsigned short hp_int;
+	unsigned char i, target;
+	unsigned long ioport;
 
-   MDISABLE_INT(ioport);
+	thisCard = ((struct sccb_card *)pCurrCard)->cardIndex;
+	ioport = ((struct sccb_card *)pCurrCard)->ioPort;
 
-   if ((bm_int_st=RD_HARPOON(ioport+hp_int_status)) & EXT_STATUS_ON)
-		bm_status = RD_HARPOON(ioport+hp_ext_status) & (unsigned char)BAD_EXT_STATUS;
-   else
-      bm_status = 0;
+	MDISABLE_INT(ioport);
 
-   WR_HARPOON(ioport+hp_int_mask, (INT_CMD_COMPL | SCSI_INTERRUPT));
+	if ((bm_int_st = RD_HARPOON(ioport + hp_int_status)) & EXT_STATUS_ON)
+		bm_status =
+		    RD_HARPOON(ioport +
+			       hp_ext_status) & (unsigned char)BAD_EXT_STATUS;
+	else
+		bm_status = 0;
 
-   while ((hp_int = RDW_HARPOON((ioport+hp_intstat)) & FPT_default_intena) |
-	  bm_status)
-     {
+	WR_HARPOON(ioport + hp_int_mask, (INT_CMD_COMPL | SCSI_INTERRUPT));
 
-       currSCCB = ((struct sccb_card *)pCurrCard)->currentSCCB;
+	while ((hp_int =
+		RDW_HARPOON((ioport +
+			     hp_intstat)) & FPT_default_intena) | bm_status) {
 
-      if (hp_int & (FIFO | TIMEOUT | RESET | SCAM_SEL) || bm_status) {
-         result = FPT_SccbMgr_bad_isr(ioport,thisCard,((struct sccb_card *)pCurrCard),hp_int);
-         WRW_HARPOON((ioport+hp_intstat), (FIFO | TIMEOUT | RESET | SCAM_SEL));
-         bm_status = 0;
+		currSCCB = ((struct sccb_card *)pCurrCard)->currentSCCB;
 
-         if (result) {
+		if (hp_int & (FIFO | TIMEOUT | RESET | SCAM_SEL) || bm_status) {
+			result =
+			    FPT_SccbMgr_bad_isr(ioport, thisCard,
+						((struct sccb_card *)pCurrCard),
+						hp_int);
+			WRW_HARPOON((ioport + hp_intstat),
+				    (FIFO | TIMEOUT | RESET | SCAM_SEL));
+			bm_status = 0;
 
-            MENABLE_INT(ioport);
-            return(result);
-            }
-         }
+			if (result) {
 
+				MENABLE_INT(ioport);
+				return (result);
+			}
+		}
 
-      else if (hp_int & ICMD_COMP) {
+		else if (hp_int & ICMD_COMP) {
 
-         if ( !(hp_int & BUS_FREE) ) {
-            /* Wait for the BusFree before starting a new command.  We
-               must also check for being reselected since the BusFree
-               may not show up if another device reselects us in 1.5us or
-               less.  SRR Wednesday, 3/8/1995.
-	         */
-	   while (!(RDW_HARPOON((ioport+hp_intstat)) & (BUS_FREE | RSEL))) ;
-	 }
+			if (!(hp_int & BUS_FREE)) {
+				/* Wait for the BusFree before starting a new command.  We
+				   must also check for being reselected since the BusFree
+				   may not show up if another device reselects us in 1.5us or
+				   less.  SRR Wednesday, 3/8/1995.
+				 */
+				while (!
+				       (RDW_HARPOON((ioport + hp_intstat)) &
+					(BUS_FREE | RSEL))) ;
+			}
 
-         if (((struct sccb_card *)pCurrCard)->globalFlags & F_HOST_XFER_ACT)
+			if (((struct sccb_card *)pCurrCard)->
+			    globalFlags & F_HOST_XFER_ACT)
 
-            FPT_phaseChkFifo(ioport, thisCard);
+				FPT_phaseChkFifo(ioport, thisCard);
 
 /*         WRW_HARPOON((ioport+hp_intstat),
             (BUS_FREE | ICMD_COMP | ITAR_DISC | XFER_CNT_0));
          */
 
-		 WRW_HARPOON((ioport+hp_intstat), CLR_ALL_INT_1);
+			WRW_HARPOON((ioport + hp_intstat), CLR_ALL_INT_1);
 
-         FPT_autoCmdCmplt(ioport,thisCard);
+			FPT_autoCmdCmplt(ioport, thisCard);
 
-         }
-
-
-      else if (hp_int & ITAR_DISC)
-         {
-
-         if (((struct sccb_card *)pCurrCard)->globalFlags & F_HOST_XFER_ACT) {
-
-            FPT_phaseChkFifo(ioport, thisCard);
-
-            }
-
-         if (RD_HARPOON(ioport+hp_gp_reg_1) == SMSAVE_DATA_PTR) {
-
-            WR_HARPOON(ioport+hp_gp_reg_1, 0x00);
-            currSCCB->Sccb_XferState |= F_NO_DATA_YET;
+		}
 
-            currSCCB->Sccb_savedATC = currSCCB->Sccb_ATC;
-            }
+		else if (hp_int & ITAR_DISC) {
 
-         currSCCB->Sccb_scsistat = DISCONNECT_ST;
-         FPT_queueDisconnect(currSCCB,thisCard);
+			if (((struct sccb_card *)pCurrCard)->
+			    globalFlags & F_HOST_XFER_ACT) {
 
-            /* Wait for the BusFree before starting a new command.  We
-               must also check for being reselected since the BusFree
-               may not show up if another device reselects us in 1.5us or
-               less.  SRR Wednesday, 3/8/1995.
-             */
-	   while (!(RDW_HARPOON((ioport+hp_intstat)) & (BUS_FREE | RSEL)) &&
-		  !((RDW_HARPOON((ioport+hp_intstat)) & PHASE) &&
-		    RD_HARPOON((ioport+hp_scsisig)) ==
-		    (SCSI_BSY | SCSI_REQ | SCSI_CD | SCSI_MSG | SCSI_IOBIT))) ;
+				FPT_phaseChkFifo(ioport, thisCard);
 
-	   /*
-	     The additional loop exit condition above detects a timing problem
-	     with the revision D/E harpoon chips.  The caller should reset the
-	     host adapter to recover when 0xFE is returned.
-	   */
-	   if (!(RDW_HARPOON((ioport+hp_intstat)) & (BUS_FREE | RSEL)))
-	     {
-	       MENABLE_INT(ioport);
-	       return 0xFE;
-	     }
+			}
 
-         WRW_HARPOON((ioport+hp_intstat), (BUS_FREE | ITAR_DISC));
+			if (RD_HARPOON(ioport + hp_gp_reg_1) == SMSAVE_DATA_PTR) {
 
+				WR_HARPOON(ioport + hp_gp_reg_1, 0x00);
+				currSCCB->Sccb_XferState |= F_NO_DATA_YET;
 
-         ((struct sccb_card *)pCurrCard)->globalFlags |= F_NEW_SCCB_CMD;
+				currSCCB->Sccb_savedATC = currSCCB->Sccb_ATC;
+			}
 
-      	}
+			currSCCB->Sccb_scsistat = DISCONNECT_ST;
+			FPT_queueDisconnect(currSCCB, thisCard);
 
+			/* Wait for the BusFree before starting a new command.  We
+			   must also check for being reselected since the BusFree
+			   may not show up if another device reselects us in 1.5us or
+			   less.  SRR Wednesday, 3/8/1995.
+			 */
+			while (!
+			       (RDW_HARPOON((ioport + hp_intstat)) &
+				(BUS_FREE | RSEL))
+			       && !((RDW_HARPOON((ioport + hp_intstat)) & PHASE)
+				    && RD_HARPOON((ioport + hp_scsisig)) ==
+				    (SCSI_BSY | SCSI_REQ | SCSI_CD | SCSI_MSG |
+				     SCSI_IOBIT))) ;
 
-      else if (hp_int & RSEL) {
+			/*
+			   The additional loop exit condition above detects a timing problem
+			   with the revision D/E harpoon chips.  The caller should reset the
+			   host adapter to recover when 0xFE is returned.
+			 */
+			if (!
+			    (RDW_HARPOON((ioport + hp_intstat)) &
+			     (BUS_FREE | RSEL))) {
+				MENABLE_INT(ioport);
+				return 0xFE;
+			}
 
-         WRW_HARPOON((ioport+hp_intstat), (PROG_HLT | RSEL | PHASE | BUS_FREE));
+			WRW_HARPOON((ioport + hp_intstat),
+				    (BUS_FREE | ITAR_DISC));
 
-         if (RDW_HARPOON((ioport+hp_intstat)) & ITAR_DISC)
-		      {
-            if (((struct sccb_card *)pCurrCard)->globalFlags & F_HOST_XFER_ACT)
-			      {
-               FPT_phaseChkFifo(ioport, thisCard);
-               }
+			((struct sccb_card *)pCurrCard)->globalFlags |=
+			    F_NEW_SCCB_CMD;
 
-            if (RD_HARPOON(ioport+hp_gp_reg_1) == SMSAVE_DATA_PTR)
-			      {
-               WR_HARPOON(ioport+hp_gp_reg_1, 0x00);
-               currSCCB->Sccb_XferState |= F_NO_DATA_YET;
-               currSCCB->Sccb_savedATC = currSCCB->Sccb_ATC;
-               }
+		}
 
-            WRW_HARPOON((ioport+hp_intstat), (BUS_FREE | ITAR_DISC));
-            currSCCB->Sccb_scsistat = DISCONNECT_ST;
-            FPT_queueDisconnect(currSCCB,thisCard);
-            }
+		else if (hp_int & RSEL) {
 
-         FPT_sres(ioport,thisCard,((struct sccb_card *)pCurrCard));
-         FPT_phaseDecode(ioport,thisCard);
+			WRW_HARPOON((ioport + hp_intstat),
+				    (PROG_HLT | RSEL | PHASE | BUS_FREE));
 
-         }
+			if (RDW_HARPOON((ioport + hp_intstat)) & ITAR_DISC) {
+				if (((struct sccb_card *)pCurrCard)->
+				    globalFlags & F_HOST_XFER_ACT) {
+					FPT_phaseChkFifo(ioport, thisCard);
+				}
 
+				if (RD_HARPOON(ioport + hp_gp_reg_1) ==
+				    SMSAVE_DATA_PTR) {
+					WR_HARPOON(ioport + hp_gp_reg_1, 0x00);
+					currSCCB->Sccb_XferState |=
+					    F_NO_DATA_YET;
+					currSCCB->Sccb_savedATC =
+					    currSCCB->Sccb_ATC;
+				}
 
-      else if ((hp_int & IDO_STRT) && (!(hp_int & BUS_FREE)))
-         {
+				WRW_HARPOON((ioport + hp_intstat),
+					    (BUS_FREE | ITAR_DISC));
+				currSCCB->Sccb_scsistat = DISCONNECT_ST;
+				FPT_queueDisconnect(currSCCB, thisCard);
+			}
 
-            WRW_HARPOON((ioport+hp_intstat), (IDO_STRT | XFER_CNT_0));
-            FPT_phaseDecode(ioport,thisCard);
+			FPT_sres(ioport, thisCard,
+				 ((struct sccb_card *)pCurrCard));
+			FPT_phaseDecode(ioport, thisCard);
 
-         }
+		}
 
+		else if ((hp_int & IDO_STRT) && (!(hp_int & BUS_FREE))) {
 
-      else if ( (hp_int & IUNKWN) || (hp_int & PROG_HLT) )
-		   {
-	 	   WRW_HARPOON((ioport+hp_intstat), (PHASE | IUNKWN | PROG_HLT));
-	 	   if ((RD_HARPOON(ioport+hp_prgmcnt_0) & (unsigned char)0x3f)< (unsigned char)SELCHK)
-	    		{
-	    		FPT_phaseDecode(ioport,thisCard);
-	    		}
-	 	   else
-	    		{
-   /* Harpoon problem some SCSI target device respond to selection
-   with short BUSY pulse (<400ns) this will make the Harpoon is not able
-   to latch the correct Target ID into reg. x53.
-   The work around require to correct this reg. But when write to this
-   reg. (0x53) also increment the FIFO write addr reg (0x6f), thus we
-   need to read this reg first then restore it later. After update to 0x53 */
+			WRW_HARPOON((ioport + hp_intstat),
+				    (IDO_STRT | XFER_CNT_0));
+			FPT_phaseDecode(ioport, thisCard);
 
-	    		i = (unsigned char)(RD_HARPOON(ioport+hp_fifowrite));
-	    		target = (unsigned char)(RD_HARPOON(ioport+hp_gp_reg_3));
-	    		WR_HARPOON(ioport+hp_xfer_pad, (unsigned char) ID_UNLOCK);
-	    		WR_HARPOON(ioport+hp_select_id, (unsigned char)(target | target<<4));
-	    		WR_HARPOON(ioport+hp_xfer_pad, (unsigned char) 0x00);
-	    		WR_HARPOON(ioport+hp_fifowrite, i);
-	    		WR_HARPOON(ioport+hp_autostart_3, (AUTO_IMMED+TAG_STRT));
-	    		}
-	 	   }
+		}
 
-      else if (hp_int & XFER_CNT_0) {
+		else if ((hp_int & IUNKWN) || (hp_int & PROG_HLT)) {
+			WRW_HARPOON((ioport + hp_intstat),
+				    (PHASE | IUNKWN | PROG_HLT));
+			if ((RD_HARPOON(ioport + hp_prgmcnt_0) & (unsigned char)
+			     0x3f) < (unsigned char)SELCHK) {
+				FPT_phaseDecode(ioport, thisCard);
+			} else {
+				/* Harpoon problem some SCSI target device respond to selection
+				   with short BUSY pulse (<400ns) this will make the Harpoon is not able
+				   to latch the correct Target ID into reg. x53.
+				   The work around require to correct this reg. But when write to this
+				   reg. (0x53) also increment the FIFO write addr reg (0x6f), thus we
+				   need to read this reg first then restore it later. After update to 0x53 */
 
-         WRW_HARPOON((ioport+hp_intstat), XFER_CNT_0);
+				i = (unsigned
+				     char)(RD_HARPOON(ioport + hp_fifowrite));
+				target =
+				    (unsigned
+				     char)(RD_HARPOON(ioport + hp_gp_reg_3));
+				WR_HARPOON(ioport + hp_xfer_pad,
+					   (unsigned char)ID_UNLOCK);
+				WR_HARPOON(ioport + hp_select_id,
+					   (unsigned char)(target | target <<
+							   4));
+				WR_HARPOON(ioport + hp_xfer_pad,
+					   (unsigned char)0x00);
+				WR_HARPOON(ioport + hp_fifowrite, i);
+				WR_HARPOON(ioport + hp_autostart_3,
+					   (AUTO_IMMED + TAG_STRT));
+			}
+		}
 
-         FPT_schkdd(ioport,thisCard);
+		else if (hp_int & XFER_CNT_0) {
 
-         }
+			WRW_HARPOON((ioport + hp_intstat), XFER_CNT_0);
 
+			FPT_schkdd(ioport, thisCard);
 
-      else if (hp_int & BUS_FREE) {
+		}
 
-         WRW_HARPOON((ioport+hp_intstat), BUS_FREE);
+		else if (hp_int & BUS_FREE) {
 
-        	if (((struct sccb_card *)pCurrCard)->globalFlags & F_HOST_XFER_ACT) {
+			WRW_HARPOON((ioport + hp_intstat), BUS_FREE);
 
-           	FPT_hostDataXferAbort(ioport,thisCard,currSCCB);
-				}
+			if (((struct sccb_card *)pCurrCard)->
+			    globalFlags & F_HOST_XFER_ACT) {
 
-         FPT_phaseBusFree(ioport,thisCard);
+				FPT_hostDataXferAbort(ioport, thisCard,
+						      currSCCB);
 			}
 
+			FPT_phaseBusFree(ioport, thisCard);
+		}
 
-      else if (hp_int & ITICKLE) {
-
-         WRW_HARPOON((ioport+hp_intstat), ITICKLE);
-         ((struct sccb_card *)pCurrCard)->globalFlags |= F_NEW_SCCB_CMD;
-         }
-
-
-
-      if (((struct sccb_card *)pCurrCard)->globalFlags & F_NEW_SCCB_CMD) {
+		else if (hp_int & ITICKLE) {
 
+			WRW_HARPOON((ioport + hp_intstat), ITICKLE);
+			((struct sccb_card *)pCurrCard)->globalFlags |=
+			    F_NEW_SCCB_CMD;
+		}
 
-         ((struct sccb_card *)pCurrCard)->globalFlags &= ~F_NEW_SCCB_CMD;
+		if (((struct sccb_card *)pCurrCard)->
+		    globalFlags & F_NEW_SCCB_CMD) {
 
+			((struct sccb_card *)pCurrCard)->globalFlags &=
+			    ~F_NEW_SCCB_CMD;
 
-         if (((struct sccb_card *)pCurrCard)->currentSCCB == NULL) {
+			if (((struct sccb_card *)pCurrCard)->currentSCCB ==
+			    NULL) {
 
-            FPT_queueSearchSelect(((struct sccb_card *)pCurrCard),thisCard);
-            }
+				FPT_queueSearchSelect(((struct sccb_card *)
+						       pCurrCard), thisCard);
+			}
 
-         if (((struct sccb_card *)pCurrCard)->currentSCCB != NULL) {
-            ((struct sccb_card *)pCurrCard)->globalFlags &= ~F_NEW_SCCB_CMD;
-            FPT_ssel(ioport,thisCard);
-            }
+			if (((struct sccb_card *)pCurrCard)->currentSCCB !=
+			    NULL) {
+				((struct sccb_card *)pCurrCard)->globalFlags &=
+				    ~F_NEW_SCCB_CMD;
+				FPT_ssel(ioport, thisCard);
+			}
 
-         break;
+			break;
 
-         }
+		}
 
-      }  /*end while */
+	}			/*end while */
 
-   MENABLE_INT(ioport);
+	MENABLE_INT(ioport);
 
-   return(0);
+	return (0);
 }
 
 /*---------------------------------------------------------------------
@@ -2154,150 +2010,149 @@ static int FlashPoint_HandleInterrupt(un
  *              processing time.
  *
  *---------------------------------------------------------------------*/
-static unsigned char FPT_SccbMgr_bad_isr(unsigned long p_port, unsigned char p_card,
-				 struct sccb_card * pCurrCard, unsigned short p_int)
+static unsigned char FPT_SccbMgr_bad_isr(unsigned long p_port,
+					 unsigned char p_card,
+					 struct sccb_card *pCurrCard,
+					 unsigned short p_int)
 {
-   unsigned char temp, ScamFlg;
-   struct sccb_mgr_tar_info * currTar_Info;
-   struct nvram_info * pCurrNvRam;
-
-
-   if (RD_HARPOON(p_port+hp_ext_status) &
-         (BM_FORCE_OFF | PCI_DEV_TMOUT | BM_PARITY_ERR | PIO_OVERRUN) )
-      {
-
-      if (pCurrCard->globalFlags & F_HOST_XFER_ACT)
-         {
-
-         FPT_hostDataXferAbort(p_port,p_card, pCurrCard->currentSCCB);
-         }
-
-      if (RD_HARPOON(p_port+hp_pci_stat_cfg) & REC_MASTER_ABORT)
+	unsigned char temp, ScamFlg;
+	struct sccb_mgr_tar_info *currTar_Info;
+	struct nvram_info *pCurrNvRam;
 
-         {
-         WR_HARPOON(p_port+hp_pci_stat_cfg,
-            (RD_HARPOON(p_port+hp_pci_stat_cfg) & ~REC_MASTER_ABORT));
+	if (RD_HARPOON(p_port + hp_ext_status) &
+	    (BM_FORCE_OFF | PCI_DEV_TMOUT | BM_PARITY_ERR | PIO_OVERRUN)) {
 
-         WR_HARPOON(p_port+hp_host_blk_cnt, 0x00);
+		if (pCurrCard->globalFlags & F_HOST_XFER_ACT) {
 
-         }
-
-      if (pCurrCard->currentSCCB != NULL)
-         {
+			FPT_hostDataXferAbort(p_port, p_card,
+					      pCurrCard->currentSCCB);
+		}
 
-         if (!pCurrCard->currentSCCB->HostStatus)
-            pCurrCard->currentSCCB->HostStatus = SCCB_BM_ERR;
+		if (RD_HARPOON(p_port + hp_pci_stat_cfg) & REC_MASTER_ABORT)
+		{
+			WR_HARPOON(p_port + hp_pci_stat_cfg,
+				   (RD_HARPOON(p_port + hp_pci_stat_cfg) &
+				    ~REC_MASTER_ABORT));
 
-         FPT_sxfrp(p_port,p_card);
+			WR_HARPOON(p_port + hp_host_blk_cnt, 0x00);
 
-	     temp = (unsigned char)(RD_HARPOON(p_port+hp_ee_ctrl) &
-							(EXT_ARB_ACK | SCSI_TERM_ENA_H));
-      	WR_HARPOON(p_port+hp_ee_ctrl, ((unsigned char)temp | SEE_MS | SEE_CS));
-         WR_HARPOON(p_port+hp_ee_ctrl, temp);
+		}
 
-         if (!(RDW_HARPOON((p_port+hp_intstat)) & (BUS_FREE | RESET)))
-            {
-            FPT_phaseDecode(p_port,p_card);
-            }
-         }
-      }
+		if (pCurrCard->currentSCCB != NULL) {
 
+			if (!pCurrCard->currentSCCB->HostStatus)
+				pCurrCard->currentSCCB->HostStatus =
+				    SCCB_BM_ERR;
 
-   else if (p_int & RESET)
-         {
+			FPT_sxfrp(p_port, p_card);
 
-				WR_HARPOON(p_port+hp_clkctrl_0, CLKCTRL_DEFAULT);
-				WR_HARPOON(p_port+hp_sys_ctrl, 0x00);
-           if (pCurrCard->currentSCCB != NULL) {
+			temp = (unsigned char)(RD_HARPOON(p_port + hp_ee_ctrl) &
+					       (EXT_ARB_ACK | SCSI_TERM_ENA_H));
+			WR_HARPOON(p_port + hp_ee_ctrl,
+				   ((unsigned char)temp | SEE_MS | SEE_CS));
+			WR_HARPOON(p_port + hp_ee_ctrl, temp);
 
-               if (pCurrCard->globalFlags & F_HOST_XFER_ACT)
+			if (!
+			    (RDW_HARPOON((p_port + hp_intstat)) &
+			     (BUS_FREE | RESET))) {
+				FPT_phaseDecode(p_port, p_card);
+			}
+		}
+	}
 
-               FPT_hostDataXferAbort(p_port,p_card, pCurrCard->currentSCCB);
-               }
+	else if (p_int & RESET) {
 
+		WR_HARPOON(p_port + hp_clkctrl_0, CLKCTRL_DEFAULT);
+		WR_HARPOON(p_port + hp_sys_ctrl, 0x00);
+		if (pCurrCard->currentSCCB != NULL) {
 
-           DISABLE_AUTO(p_port);
+			if (pCurrCard->globalFlags & F_HOST_XFER_ACT)
 
-           FPT_sresb(p_port,p_card);
+				FPT_hostDataXferAbort(p_port, p_card,
+						      pCurrCard->currentSCCB);
+		}
 
-           while(RD_HARPOON(p_port+hp_scsictrl_0) & SCSI_RST) {}
+		DISABLE_AUTO(p_port);
 
-				pCurrNvRam = pCurrCard->pNvRamInfo;
-				if(pCurrNvRam){
-					ScamFlg = pCurrNvRam->niScamConf;
-				}
-				else{
-				   ScamFlg = (unsigned char) FPT_utilEERead(p_port, SCAM_CONFIG/2);
-				}
+		FPT_sresb(p_port, p_card);
 
-           FPT_XbowInit(p_port, ScamFlg);
+		while (RD_HARPOON(p_port + hp_scsictrl_0) & SCSI_RST) {
+		}
 
-               FPT_scini(p_card, pCurrCard->ourId, 0);
+		pCurrNvRam = pCurrCard->pNvRamInfo;
+		if (pCurrNvRam) {
+			ScamFlg = pCurrNvRam->niScamConf;
+		} else {
+			ScamFlg =
+			    (unsigned char)FPT_utilEERead(p_port,
+							  SCAM_CONFIG / 2);
+		}
 
-           return(0xFF);
-         }
+		FPT_XbowInit(p_port, ScamFlg);
 
+		FPT_scini(p_card, pCurrCard->ourId, 0);
 
-   else if (p_int & FIFO) {
+		return (0xFF);
+	}
 
-      WRW_HARPOON((p_port+hp_intstat), FIFO);
+	else if (p_int & FIFO) {
 
-      if (pCurrCard->currentSCCB != NULL)
-         FPT_sxfrp(p_port,p_card);
-      }
+		WRW_HARPOON((p_port + hp_intstat), FIFO);
 
-   else if (p_int & TIMEOUT)
-      {
+		if (pCurrCard->currentSCCB != NULL)
+			FPT_sxfrp(p_port, p_card);
+	}
 
-      DISABLE_AUTO(p_port);
+	else if (p_int & TIMEOUT) {
 
-      WRW_HARPOON((p_port+hp_intstat),
-		  (PROG_HLT | TIMEOUT | SEL |BUS_FREE | PHASE | IUNKWN));
+		DISABLE_AUTO(p_port);
 
-      pCurrCard->currentSCCB->HostStatus = SCCB_SELECTION_TIMEOUT;
+		WRW_HARPOON((p_port + hp_intstat),
+			    (PROG_HLT | TIMEOUT | SEL | BUS_FREE | PHASE |
+			     IUNKWN));
 
+		pCurrCard->currentSCCB->HostStatus = SCCB_SELECTION_TIMEOUT;
 
-		currTar_Info = &FPT_sccbMgrTbl[p_card][pCurrCard->currentSCCB->TargID];
-		if((pCurrCard->globalFlags & F_CONLUN_IO) &&
-			((currTar_Info->TarStatus & TAR_TAG_Q_MASK) != TAG_Q_TRYING))
-	      currTar_Info->TarLUNBusy[pCurrCard->currentSCCB->Lun] = 0;
+		currTar_Info =
+		    &FPT_sccbMgrTbl[p_card][pCurrCard->currentSCCB->TargID];
+		if ((pCurrCard->globalFlags & F_CONLUN_IO)
+		    && ((currTar_Info->TarStatus & TAR_TAG_Q_MASK) !=
+			TAG_Q_TRYING))
+			currTar_Info->TarLUNBusy[pCurrCard->currentSCCB->Lun] =
+			    0;
 		else
-	      currTar_Info->TarLUNBusy[0] = 0;
+			currTar_Info->TarLUNBusy[0] = 0;
 
+		if (currTar_Info->TarEEValue & EE_SYNC_MASK) {
+			currTar_Info->TarSyncCtrl = 0;
+			currTar_Info->TarStatus &= ~TAR_SYNC_MASK;
+		}
 
-      if (currTar_Info->TarEEValue & EE_SYNC_MASK)
-         {
-	       currTar_Info->TarSyncCtrl = 0;
-         currTar_Info->TarStatus &= ~TAR_SYNC_MASK;
-         }
-
-      if (currTar_Info->TarEEValue & EE_WIDE_SCSI)
-         {
-         currTar_Info->TarStatus &= ~TAR_WIDE_MASK;
-         }
+		if (currTar_Info->TarEEValue & EE_WIDE_SCSI) {
+			currTar_Info->TarStatus &= ~TAR_WIDE_MASK;
+		}
 
-      FPT_sssyncv(p_port, pCurrCard->currentSCCB->TargID, NARROW_SCSI,currTar_Info);
+		FPT_sssyncv(p_port, pCurrCard->currentSCCB->TargID, NARROW_SCSI,
+			    currTar_Info);
 
-      FPT_queueCmdComplete(pCurrCard, pCurrCard->currentSCCB, p_card);
+		FPT_queueCmdComplete(pCurrCard, pCurrCard->currentSCCB, p_card);
 
-      }
+	}
 
-   else if (p_int & SCAM_SEL)
-      {
+	else if (p_int & SCAM_SEL) {
 
-      FPT_scarb(p_port,LEVEL2_TAR);
-      FPT_scsel(p_port);
-      FPT_scasid(p_card, p_port);
+		FPT_scarb(p_port, LEVEL2_TAR);
+		FPT_scsel(p_port);
+		FPT_scasid(p_card, p_port);
 
-      FPT_scbusf(p_port);
+		FPT_scbusf(p_port);
 
-      WRW_HARPOON((p_port+hp_intstat), SCAM_SEL);
-      }
+		WRW_HARPOON((p_port + hp_intstat), SCAM_SEL);
+	}
 
-   return(0x00);
+	return (0x00);
 }
 
-
 /*---------------------------------------------------------------------
  *
  * Function: SccbMgrTableInit
@@ -2308,21 +2163,19 @@ static unsigned char FPT_SccbMgr_bad_isr
 
 static void FPT_SccbMgrTableInitAll()
 {
-   unsigned char thisCard;
+	unsigned char thisCard;
 
-   for (thisCard = 0; thisCard < MAX_CARDS; thisCard++)
-      {
-      FPT_SccbMgrTableInitCard(&FPT_BL_Card[thisCard],thisCard);
+	for (thisCard = 0; thisCard < MAX_CARDS; thisCard++) {
+		FPT_SccbMgrTableInitCard(&FPT_BL_Card[thisCard], thisCard);
 
-      FPT_BL_Card[thisCard].ioPort      = 0x00;
-      FPT_BL_Card[thisCard].cardInfo    = NULL;
-      FPT_BL_Card[thisCard].cardIndex   = 0xFF;
-      FPT_BL_Card[thisCard].ourId       = 0x00;
-		FPT_BL_Card[thisCard].pNvRamInfo	= NULL;
-      }
+		FPT_BL_Card[thisCard].ioPort = 0x00;
+		FPT_BL_Card[thisCard].cardInfo = NULL;
+		FPT_BL_Card[thisCard].cardIndex = 0xFF;
+		FPT_BL_Card[thisCard].ourId = 0x00;
+		FPT_BL_Card[thisCard].pNvRamInfo = NULL;
+	}
 }
 
-
 /*---------------------------------------------------------------------
  *
  * Function: SccbMgrTableInit
@@ -2331,33 +2184,30 @@ static void FPT_SccbMgrTableInitAll()
  *
  *---------------------------------------------------------------------*/
 
-static void FPT_SccbMgrTableInitCard(struct sccb_card * pCurrCard, unsigned char p_card)
+static void FPT_SccbMgrTableInitCard(struct sccb_card *pCurrCard,
+				     unsigned char p_card)
 {
-   unsigned char scsiID, qtag;
+	unsigned char scsiID, qtag;
 
-	for (qtag = 0; qtag < QUEUE_DEPTH; qtag++)
-	{
+	for (qtag = 0; qtag < QUEUE_DEPTH; qtag++) {
 		FPT_BL_Card[p_card].discQ_Tbl[qtag] = NULL;
 	}
 
-   for (scsiID = 0; scsiID < MAX_SCSI_TAR; scsiID++)
-      {
-      FPT_sccbMgrTbl[p_card][scsiID].TarStatus = 0;
-      FPT_sccbMgrTbl[p_card][scsiID].TarEEValue = 0;
-      FPT_SccbMgrTableInitTarget(p_card, scsiID);
-      }
+	for (scsiID = 0; scsiID < MAX_SCSI_TAR; scsiID++) {
+		FPT_sccbMgrTbl[p_card][scsiID].TarStatus = 0;
+		FPT_sccbMgrTbl[p_card][scsiID].TarEEValue = 0;
+		FPT_SccbMgrTableInitTarget(p_card, scsiID);
+	}
 
-   pCurrCard->scanIndex = 0x00;
-   pCurrCard->currentSCCB = NULL;
-   pCurrCard->globalFlags = 0x00;
-   pCurrCard->cmdCounter  = 0x00;
+	pCurrCard->scanIndex = 0x00;
+	pCurrCard->currentSCCB = NULL;
+	pCurrCard->globalFlags = 0x00;
+	pCurrCard->cmdCounter = 0x00;
 	pCurrCard->tagQ_Lst = 0x01;
-	pCurrCard->discQCount = 0; 
-
+	pCurrCard->discQCount = 0;
 
 }
 
-
 /*---------------------------------------------------------------------
  *
  * Function: SccbMgrTableInit
@@ -2366,11 +2216,12 @@ static void FPT_SccbMgrTableInitCard(str
  *
  *---------------------------------------------------------------------*/
 
-static void FPT_SccbMgrTableInitTarget(unsigned char p_card, unsigned char target)
+static void FPT_SccbMgrTableInitTarget(unsigned char p_card,
+				       unsigned char target)
 {
 
 	unsigned char lun, qtag;
-	struct sccb_mgr_tar_info * currTar_Info;
+	struct sccb_mgr_tar_info *currTar_Info;
 
 	currTar_Info = &FPT_sccbMgrTbl[p_card][target];
 
@@ -2382,19 +2233,15 @@ static void FPT_SccbMgrTableInitTarget(u
 	currTar_Info->TarTagQ_Cnt = 0;
 	currTar_Info->TarLUN_CA = 0;
 
-
-	for (lun = 0; lun < MAX_LUN; lun++)
-	{
+	for (lun = 0; lun < MAX_LUN; lun++) {
 		currTar_Info->TarLUNBusy[lun] = 0;
 		currTar_Info->LunDiscQ_Idx[lun] = 0;
 	}
 
-	for (qtag = 0; qtag < QUEUE_DEPTH; qtag++)
-	{
-		if(FPT_BL_Card[p_card].discQ_Tbl[qtag] != NULL)
-		{
-			if(FPT_BL_Card[p_card].discQ_Tbl[qtag]->TargID == target)
-			{
+	for (qtag = 0; qtag < QUEUE_DEPTH; qtag++) {
+		if (FPT_BL_Card[p_card].discQ_Tbl[qtag] != NULL) {
+			if (FPT_BL_Card[p_card].discQ_Tbl[qtag]->TargID ==
+			    target) {
 				FPT_BL_Card[p_card].discQ_Tbl[qtag] = NULL;
 				FPT_BL_Card[p_card].discQCount--;
 			}
@@ -2402,7 +2249,6 @@ static void FPT_SccbMgrTableInitTarget(u
 	}
 }
 
-
 /*---------------------------------------------------------------------
  *
  * Function: sfetm
@@ -2412,71 +2258,66 @@ static void FPT_SccbMgrTableInitTarget(u
  *
  *---------------------------------------------------------------------*/
 
-static unsigned char FPT_sfm(unsigned long port, struct sccb * pCurrSCCB)
+static unsigned char FPT_sfm(unsigned long port, struct sccb *pCurrSCCB)
 {
 	unsigned char message;
 	unsigned short TimeOutLoop;
 
 	TimeOutLoop = 0;
-	while( (!(RD_HARPOON(port+hp_scsisig) & SCSI_REQ)) &&
-			(TimeOutLoop++ < 20000) ){}
-
-
-	WR_HARPOON(port+hp_portctrl_0, SCSI_PORT);
+	while ((!(RD_HARPOON(port + hp_scsisig) & SCSI_REQ)) &&
+	       (TimeOutLoop++ < 20000)) {
+	}
 
-	message = RD_HARPOON(port+hp_scsidata_0);
+	WR_HARPOON(port + hp_portctrl_0, SCSI_PORT);
 
-	WR_HARPOON(port+hp_scsisig, SCSI_ACK + S_MSGI_PH);
+	message = RD_HARPOON(port + hp_scsidata_0);
 
+	WR_HARPOON(port + hp_scsisig, SCSI_ACK + S_MSGI_PH);
 
 	if (TimeOutLoop > 20000)
-		message = 0x00;   /* force message byte = 0 if Time Out on Req */
+		message = 0x00;	/* force message byte = 0 if Time Out on Req */
 
-	if ((RDW_HARPOON((port+hp_intstat)) & PARITY) &&
-		(RD_HARPOON(port+hp_addstat) & SCSI_PAR_ERR))
-	{
-		WR_HARPOON(port+hp_scsisig, (SCSI_ACK + S_ILL_PH));
-		WR_HARPOON(port+hp_xferstat, 0);
-		WR_HARPOON(port+hp_fiforead, 0);
-		WR_HARPOON(port+hp_fifowrite, 0);
-		if (pCurrSCCB != NULL)
-		{
+	if ((RDW_HARPOON((port + hp_intstat)) & PARITY) &&
+	    (RD_HARPOON(port + hp_addstat) & SCSI_PAR_ERR)) {
+		WR_HARPOON(port + hp_scsisig, (SCSI_ACK + S_ILL_PH));
+		WR_HARPOON(port + hp_xferstat, 0);
+		WR_HARPOON(port + hp_fiforead, 0);
+		WR_HARPOON(port + hp_fifowrite, 0);
+		if (pCurrSCCB != NULL) {
 			pCurrSCCB->Sccb_scsimsg = SMPARITY;
 		}
 		message = 0x00;
-		do
-		{
+		do {
 			ACCEPT_MSG_ATN(port);
 			TimeOutLoop = 0;
-			while( (!(RD_HARPOON(port+hp_scsisig) & SCSI_REQ)) &&
-				(TimeOutLoop++ < 20000) ){}
-			if (TimeOutLoop > 20000)
-			{
-				WRW_HARPOON((port+hp_intstat), PARITY);
-				return(message);
+			while ((!(RD_HARPOON(port + hp_scsisig) & SCSI_REQ)) &&
+			       (TimeOutLoop++ < 20000)) {
 			}
-			if ((RD_HARPOON(port+hp_scsisig) & S_SCSI_PHZ) != S_MSGI_PH)
-			{
-				WRW_HARPOON((port+hp_intstat), PARITY);
-				return(message);
+			if (TimeOutLoop > 20000) {
+				WRW_HARPOON((port + hp_intstat), PARITY);
+				return (message);
+			}
+			if ((RD_HARPOON(port + hp_scsisig) & S_SCSI_PHZ) !=
+			    S_MSGI_PH) {
+				WRW_HARPOON((port + hp_intstat), PARITY);
+				return (message);
 			}
-			WR_HARPOON(port+hp_portctrl_0, SCSI_PORT);
+			WR_HARPOON(port + hp_portctrl_0, SCSI_PORT);
 
-			RD_HARPOON(port+hp_scsidata_0);
+			RD_HARPOON(port + hp_scsidata_0);
 
-			WR_HARPOON(port+hp_scsisig, (SCSI_ACK + S_ILL_PH));
+			WR_HARPOON(port + hp_scsisig, (SCSI_ACK + S_ILL_PH));
 
-		}while(1);
+		} while (1);
 
 	}
-	WR_HARPOON(port+hp_scsisig, (SCSI_ACK + S_ILL_PH));
-	WR_HARPOON(port+hp_xferstat, 0);
-	WR_HARPOON(port+hp_fiforead, 0);
-	WR_HARPOON(port+hp_fifowrite, 0);
-	return(message);
+	WR_HARPOON(port + hp_scsisig, (SCSI_ACK + S_ILL_PH));
+	WR_HARPOON(port + hp_xferstat, 0);
+	WR_HARPOON(port + hp_fiforead, 0);
+	WR_HARPOON(port + hp_fifowrite, 0);
+	return (message);
 }
 
-
 /*---------------------------------------------------------------------
  *
  * Function: FPT_ssel
